﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Xml;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Content.Pipeline.Graphics;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Compiler;
using Microsoft.Xna.Framework.Graphics;
using D=System.Drawing;
using XnaColor = Microsoft.Xna.Framework.Graphics.Color;



namespace PolygonHead
{


    public class AcientBitmapFont
    {
        #region Members var
        protected int mBaseLine;

        protected Dictionary<char, Character> mCharacters;

        protected char mDefaultCharacter;

        protected Dictionary<char, Glyph> mGlyphs;

        protected Dictionary<char, Dictionary<char, int>> mKerning;

        protected int mLineHeight;

        protected int mSpacing;

        protected Texture2D mTexture;

        public int Baseline
        {
            get
            {
                return this.mBaseLine;
            }
            set
            {
                this.mBaseLine = value;
            }
        }

        public int LineHeight
        {
            get
            {
                return this.mLineHeight;
            }
        }

        public int Spacing
        {
            get
            {
                return this.mSpacing;
            }
        }

        public Texture2D Texture
        {
            get
            {
                return this.mTexture;
            }
        }

        #endregion


        public AcientBitmapFont()
        {
        }

        #region 重要度の低い物
        public int CalcKern(char iLeft, char iRight)
        {
            Dictionary<char, int> chrs = null;
            int num = 0;
            if (this.mKerning.TryGetValue(iLeft, out chrs) && chrs.TryGetValue(iRight, out num))
            {
                return num;
            }
            return 0;
        }

        public Vector2 MeasureText(char[] iText, bool iKern)
        {
            return this.MeasureText(iText, iKern, (int)iText.Length);
        }

        public Vector2 MeasureText(char[] iText, bool iKern, int iLength)
        {
            Glyph glyph;
            Glyph glyph2;
            Vector2 y = new Vector2();
            y.Y = (float)this.mLineHeight;
            int advanceWidth = 0;
            char chr1 = '\0';
            bool flag = false;
            iLength = Math.Min((int)iText.Length, iLength);
            int num = 0;
            while (num < iLength)
            {
                char chr2 = iText[num];
                if (flag)
                {
                    if (chr2 == 91)
                    {
                        this.GetGlyph(chr2, out glyph);
                        if (iKern)
                        {
                            advanceWidth = advanceWidth + this.CalcKern(chr1, chr2);
                            chr1 = chr2;
                        }
                        advanceWidth = advanceWidth + glyph.AdvanceWidth + this.mSpacing;
                        flag = false;
                        continue;
                    }
                    if (chr2 == 93)
                    {
                        flag = false;
                        continue;
                    }
                }
                else
                {
                    if (chr2 != '\0')
                    {
                        if (chr2 == 10)
                        {
                            y.Y = y.Y + (float)this.mLineHeight;
                            y.X = Math.Max(y.X, (float)advanceWidth);
                            advanceWidth = 0;
                        }
                        if (chr2 == 91 && !flag)
                        {
                            flag = true;
                            continue;
                        }
                        this.GetGlyph(chr2, out glyph2);
                        if (iKern)
                        {
                            advanceWidth = advanceWidth + this.CalcKern(chr1, chr2);
                            chr1 = chr2;
                        }
                        advanceWidth = advanceWidth + glyph2.AdvanceWidth + this.mSpacing;
                        num++;
                    }
                }
            }
            y.X = Math.Max(y.X, (float)advanceWidth);
            if (y.X > 1)
            {
                y.X = y.X - (float)this.mSpacing;
            }
            return y;
        }

        public Vector2 MeasureText(string iText, bool iKern)
        {
            return this.MeasureText(iText, iKern, iText.Length);
        }

        public Vector2 MeasureText(string iText, bool iKern, int iLength)
        {
            Glyph glyph;
            Glyph glyph2;
            Vector2 y = new Vector2();
            y.Y = (float)this.mLineHeight;
            int advanceWidth = 0;
            char chr = '\0';
            bool flag = false;
            iLength = Math.Min(iText.Length, iLength);
            int num = 0;
            while (num < iLength)
            {
                char chars = iText[num];
                if (flag)
                {
                    if (chars == 91)
                    {
                        this.GetGlyph(chars, out glyph);
                        if (iKern)
                        {
                            advanceWidth = advanceWidth + this.CalcKern(chr, chars);
                            chr = chars;
                        }
                        advanceWidth = advanceWidth + glyph.AdvanceWidth + this.mSpacing;
                        flag = false;
                        continue;
                    }
                    if (chars == 93)
                    {
                        flag = false;
                        continue;
                    }
                }
                else
                {
                    if (chars != '\0')
                    {
                        if (chars == 10)
                        {
                            y.Y = y.Y + (float)this.mLineHeight;
                            y.X = Math.Max(y.X, (float)advanceWidth);
                            advanceWidth = 0;
                        }
                        if (chars == 91 && !flag)
                        {
                            flag = true;
                            continue;
                        }
                        this.GetGlyph(chars, out glyph2);
                        if (iKern)
                        {
                            advanceWidth = advanceWidth + this.CalcKern(chr, chars);
                            chr = chars;
                        }
                        advanceWidth = advanceWidth + glyph2.AdvanceWidth + this.mSpacing;
                        num++;
                    }
                }
            }
            y.X = Math.Max(y.X, (float)advanceWidth);
            if (y.X > 1)
            {
                y.X = y.X - (float)this.mSpacing;
            }
            return y;
        }
        public string Wrap(string iText, int iTargetLineWidth, bool iKern)
        {
            return this.Wrap(iText, iTargetLineWidth, iKern, out iTargetLineWidth);
        }

        public string Wrap(string iText, int iTargetLineWidth, bool iKern, out int oLineWidth)
        {
            int length = 0;
            Glyph glyph;
            // Glyph glyph2;
            string str = "";
            while (!false)
            {
                str = "";
                for (int i = 0; i < iText.Length; i = length + 1)
                {
                    length = iText.Length;
                    int num1 = 0;
                    int advanceWidth = 0;
                    char chr = '\0';
                    bool flag = false;
                    int num2 = i;
                    while (num2 < iText.Length)
                    {
                        char chars = iText[num2];
                        if (flag)
                        {
                            if (chars == 91)
                            {
                                this.GetGlyph(chars, out glyph);
                                if (iKern)
                                {
                                    advanceWidth = advanceWidth + this.CalcKern(chr, chars);
                                    chr = chars;
                                }
                                advanceWidth = advanceWidth + glyph.AdvanceWidth + this.mSpacing;
                                flag = false;
                            }
                            else
                            {
                                if (chars == 93)
                                {
                                    flag = false;
                                }
                                if (chars == 32)
                                {
                                    if (advanceWidth <= iTargetLineWidth || num2 < length)
                                    {
                                        length = num2;
                                        num1 = advanceWidth;
                                    }
                                }
                                if (chars != '\0')
                                {
                                    if (chars == 10)
                                    {
                                        length = num2;
                                    }
                                    else
                                    {
                                        if (chars == 91 && !flag)
                                        {
                                            flag = true;
                                        }
                                        if (advanceWidth <= iTargetLineWidth || num2 >= length)
                                        {
                                            break;
                                        }
                                        num2++;
                                    }
                                }
                            }
                        }
                    }
                    if (num2 == iText.Length && advanceWidth <= iTargetLineWidth)
                    {
                        num1 = advanceWidth;
                        length = num2;
                    }
                    if (num1 > iTargetLineWidth)
                    {
                        iTargetLineWidth = num1;
                        break;
                    }
                    str = string.Concat(str, iText.Substring(i, length - i));
                    if (length < iText.Length)
                    {
                        str = string.Concat(str, 10);
                    }
                }
            }
            //oLineWidth = iTargetLineWidth;
            //return str;
        }


        public bool GetCharacter(char iChar, out Character oChar)
        {
            if (!this.mCharacters.TryGetValue(iChar, out oChar))
            {
                if (!this.mCharacters.TryGetValue(this.mDefaultCharacter, out oChar))
                {

                    //Enumerat<char, Character> 
                    var enumerator = this.mCharacters.Values.GetEnumerator();
                    enumerator.MoveNext();
                    oChar = enumerator.Current;
                }
                return false;
            }
            return true;
        }

        public bool GetGlyph(char iChar, out Glyph oGlyph)
        {
            if (!this.mGlyphs.TryGetValue(iChar, out oGlyph))
            {
                if (!this.mGlyphs.TryGetValue(this.mDefaultCharacter, out oGlyph))
                {
                    //Enumerat<char, Glyph> 
                    var enumerator = this.mGlyphs.Values.GetEnumerator();
                    enumerator.MoveNext();
                    oGlyph = enumerator.Current;
                }
                return false;
            }
            return true;
        }
        #endregion

        public void Read(ContentReader iInput)
        {

            int num1 = 0;
            Glyph glyph;
            Character character;
            Dictionary<char, int> chrs = null;
            this.mSpacing = 0;
            this.mLineHeight = iInput.ReadInt32();
            this.mBaseLine = iInput.ReadInt32();
            this.mDefaultCharacter = iInput.ReadChar();
            GraphicsDevice graphicsDevice1 = null;
            for (int i = 0; i < num1; i++)
            {
                glyph = Glyph.Read(iInput);
                this.mGlyphs.Add(glyph.Character, glyph);
                character = Character.FromGlyph(glyph, Vector4.One, this.mTexture.Width, (float)this.mTexture.Height);
                this.mCharacters.Add(glyph.Character, character);
            }
            GraphicsDevice graphicsDevice2 = graphicsDevice1;
            //Monitor.Enter(graphicsDevice2);
            try
            {
                this.mTexture = iInput.ReadObject<Texture2D>();
            }
            finally
            {
                //Monitor.Exit(graphicsDevice2);
            }
            num1 = iInput.ReadInt32();
            this.mGlyphs = new Dictionary<char, Glyph>(); // (num1)
            this.mCharacters = new Dictionary<char, Character>(); // (num1)
            for (int i = 0; i < num1; i++)
            {
                glyph = Glyph.Read(iInput);
                this.mGlyphs.Add(glyph.Character, glyph);
                character = Character.FromGlyph(glyph, Vector4.One, this.mTexture.Width, (float)this.mTexture.Height);
                this.mCharacters.Add(glyph.Character, character);
            }
            int num2 = iInput.ReadInt32();
            this.mKerning = new Dictionary<char, Dictionary<char, int>>();
            int num3 = 0;
            while (num3 < num2)
            {
                char chr1 = iInput.ReadChar();
                char chr2 = iInput.ReadChar();
                int num4 = iInput.ReadInt32();
                if (!this.mKerning.TryGetValue(chr1, out chrs))
                {
                    chrs = new Dictionary<char, int>();
                    this.mKerning.Add(chr1, chrs);
                }
                chrs.Add(chr2, num4);
                num3++;
            }
        }

        public void Read(BitmapFont iBitmapFont)
        {
            this.mSpacing = 0;
            this.mLineHeight = iBitmapFont.mLineHeight;
            this.mBaseLine = iBitmapFont.mBaseLine;
            this.mDefaultCharacter = iBitmapFont.mDefaultCharacter;
            this.mTexture = iBitmapFont.mTexture;
            this.mGlyphs.Clear();
            foreach (KeyValuePair<char, Glyph> mGlyph in iBitmapFont.mGlyphs)
            {
                this.mGlyphs.Add(mGlyph.Key, mGlyph.Value);
            }
            this.mCharacters.Clear();
            foreach (KeyValuePair<char, Character> mCharacter in iBitmapFont.mCharacters)
            {
                this.mCharacters.Add(mCharacter.Key, mCharacter.Value);
            }
            this.mKerning.Clear();
            foreach (KeyValuePair<char, Dictionary<char, int>> keyValuePair in iBitmapFont.mKerning)
            {
                Dictionary<char, int> chrs = new Dictionary<char, int>();
                foreach (KeyValuePair<char, int> @value in keyValuePair.Value)
                {
                    chrs.Add(@value.Key, @value.Value);
                }
                this.mKerning.Add(keyValuePair.Key, chrs);
            }
        }


    }

    public class BitmapFont: AcientBitmapFont
    {

        public BitmapFont()
        {
        }
        public BitmapFont(Stream XmlStream)
        {
            this.LoadPackageXML(XmlStream);
        }

        // my function
        public void Write(ContentWriter iOutput)
        {
            iOutput.Write((Int32)this.mLineHeight);
            iOutput.Write((Int32)this.mBaseLine);
            iOutput.Write((Char)this.mDefaultCharacter);


            //ここでglyphを処理してるらしいが、謎

            // Monitor.Enter

            iOutput.WriteObject<Texture2DContent>(T2D2T2C(this.mTexture));
            //iOutput.WriteObject<Texture2DContent>(null);

            /*
            Texture2DContent tc = new Texture2DContent();
            PixelBitmapContent<Vector4> pbc = new PixelBitmapContent<Vector4>(this.mTexture.Width, this.mTexture.Height);
            Byte[] buf = null;
            this.mTexture.GetData<Byte>(buf);
            pbc.SetPixelData(buf);
            tc.Mipmaps.Add(pbc);
            iOutput.WriteObject<Texture2DContent>(tc);*/

            //            iOutput.WriteObject<Texture2D>(this.mTexture); 
            //iOutput.WriteObject<Texture2D>(null);

            int num1 = this.mGlyphs.Count;
            iOutput.Write((Int32)num1);

            foreach (var glyph in this.mGlyphs)
            {
                glyph.Value.Write(ref iOutput);
            }

            int num2 = 0;
            foreach (var ker in this.mKerning)
            {
                num2 += ker.Value.Count;
            }
            iOutput.Write((Int32)num2);

            foreach (var eKerning in this.mKerning)
            {
                Char chr1 = eKerning.Key;
                var chrs = eKerning.Value;

                foreach (var eChrs in chrs)
                {
                    Char chr2 = eChrs.Key;
                    int num4 = eChrs.Value;

                    iOutput.Write(chr1);
                    iOutput.Write(chr2);
                    iOutput.Write(num4);
                }
            }


        }
        public void LoadPackageXML(Stream strm)
        {
            //using (XmlTextReader reader = new XmlTextReader(strm))

            #region XML読み込み
            {
                XmlDocument XD = new XmlDocument();
                XD.Load(strm);
                {
                    var attrib = XD.GetElementsByTagName("BitmapFont")[0].Attributes; //決め撃ち
                    this.mBaseLine = int.Parse(attrib["mBaseLine"].Value);
                    this.mDefaultCharacter = attrib["mDefaultCharacter"].Value[0];
                    this.mLineHeight = int.Parse(attrib["mLineHeight"].Value);
                    this.mSpacing = int.Parse(attrib["mSpacing"].Value);
                }

                {
                    this.mGlyphs = new Dictionary<char, Glyph>();
                    var eGlyphsItems = XD.GetElementsByTagName("mGlyphsItem");
                    foreach (XmlNode item in eGlyphsItems)
                    {
                        Glyph g = new Glyph();
                        var attr = item.Attributes;

                        g.AdvanceWidth = int.Parse(attr["AdvanceWidth"].Value);
                        g.Character = attr["Character"].Value[0];
                        g.ForceWhite = Boolean.Parse(attr["ForceWhite"].Value);
                        g.Origin = new Point();
                        g.Origin.X = int.Parse(attr["OriginX"].Value);
                        g.Origin.Y = int.Parse(attr["OriginY"].Value);
                        g.Size = new Point();
                        g.Size.X = int.Parse(attr["SizeX"].Value);
                        g.Size.Y = int.Parse(attr["SizeY"].Value);
                        this.mGlyphs.Add(g.Character, g);
                    }
                }

                try
                {
                    this.mKerning = new Dictionary<char, Dictionary<char, int>>();
                    foreach (XmlNode item in XD.GetElementsByTagName("mKerningItem"))
                    {
                        Char baseChar = item.Attributes["char"].Value[0];
                        Dictionary<Char, int> kerning = new Dictionary<char, int>();
                        foreach (XmlNode subitem in item.ChildNodes)
                        {
                            Char tgtChar = subitem.Attributes["char"].Value[0];
                            int kerningOffset = int.Parse(subitem.Attributes["value"].Value);
                            kerning[tgtChar] = kerningOffset;
                        }
                        this.mKerning[baseChar] = kerning;
                    }
                }
                catch (Exception e)
                {

                    throw new Exception("要素名<mKerningItem>にてエラー.", e);
                }

                {
                    var prezOption = new PresentationParameters();
                    using (System.Windows.Forms.Form dummyForm = new System.Windows.Forms.Form())
                    {
                        //using (
                        GraphicsDevice graphicsDev = new GraphicsDevice(GraphicsAdapter.DefaultAdapter, DeviceType.Hardware, dummyForm.Handle, prezOption);//)
                        {
                            var elem = XD.GetElementsByTagName("Textrue")[0].FirstChild;
                            var imageData = Convert.FromBase64String(elem.Value);
                            using (var memStrm = new MemoryStream(imageData))
                            {
                                this.mTexture = Texture2D.FromFile(graphicsDev, memStrm);

                            }
                        }
                    }
                }
            }
            #endregion

            {
                mCharacters = new Dictionary<char, Character>();
                foreach (var glyph in this.mGlyphs)
                {
                    Character ch = Character.FromGlyph(glyph.Value, Vector4.One, this.Texture.Width, this.Texture.Height);

                    mCharacters[glyph.Key] = ch;
                }
            }
        }
        public void SavePackageXML(Stream strm)
        {
            using (XmlTextWriter writter = new XmlTextWriter(strm, System.Text.Encoding.UTF8))
            {
                writter.WriteStartElement("BitmapFont");
                writter.WriteAttributeString("mBaseLine", this.mBaseLine.ToString());
                writter.WriteAttributeString("mDefaultCharacter", this.mDefaultCharacter.ToString());
                writter.WriteAttributeString("mLineHeight", this.mLineHeight.ToString());
                writter.WriteAttributeString("mSpacing", this.mSpacing.ToString());

                foreach (var item in this.mGlyphs.Values)
                {
                    writter.WriteStartElement("mGlyphsItem");
                    writter.WriteAttributeString("AdvanceWidth", item.AdvanceWidth.ToString());
                    writter.WriteAttributeString("Character", item.Character.ToString());
                    writter.WriteAttributeString("ForceWhite", item.ForceWhite.ToString());
                    writter.WriteAttributeString("LeftSideBearing", item.LeftSideBearing.ToString());
                    writter.WriteAttributeString("OriginX", item.Origin.X.ToString());
                    writter.WriteAttributeString("OriginY", item.Origin.Y.ToString());
                    writter.WriteAttributeString("SizeX", item.Size.X.ToString());
                    writter.WriteAttributeString("SizeY", item.Size.Y.ToString());
                    writter.WriteEndElement();
                }

                foreach (var item in this.mKerning)
                {
                    writter.WriteStartElement("mKerningItem");

                    writter.WriteAttributeString("char", item.Key.ToString());
                    foreach (var subitem in item.Value)
                    {
                        writter.WriteStartElement("kerning");
                        writter.WriteAttributeString("char", subitem.Key.ToString());
                        writter.WriteAttributeString("value", subitem.Value.ToString());
                        writter.WriteEndElement();
                    }
                    writter.WriteEndElement();
                }

                {
                    var temp = Path.GetTempFileName();
                    this.Texture.Save(temp, ImageFileFormat.Png);
                    Byte[] texBuf = File.ReadAllBytes(temp);
                    File.Delete(temp);

                    writter.WriteStartElement("Textrue");
                    writter.WriteBase64(texBuf, 0, texBuf.Length);
                    writter.WriteEndElement();

                }

                writter.WriteEndElement();
            }

        }

        public void SaveIndividual(String path)
        {
            var beforeCurrentPath = Directory.GetCurrentDirectory();
            Directory.CreateDirectory(path);
            Directory.SetCurrentDirectory(path);
            this.mTexture.Save("preview.png",ImageFileFormat.Png);
            System.Drawing.Bitmap sourceBmp;
            using(var tempbmp = new System.Drawing.Bitmap("preview.png"))
            {
                sourceBmp = new System.Drawing.Bitmap(tempbmp);
            }
           

            
            using (XmlTextWriter xml = new XmlTextWriter("glyphs.xml",System.Text.Encoding.UTF8))
            {
                xml.WriteStartElement("PngFonts");
                xml.WriteAttributeString("mBaseLine", this.mBaseLine.ToString());
                xml.WriteAttributeString("mDefaultCharacter", this.mDefaultCharacter.ToString());
                xml.WriteAttributeString("mLineHeight", this.mLineHeight.ToString());
                xml.WriteAttributeString("mSpacing", this.mSpacing.ToString());

                int glyphCount = 0;
                foreach(var glyph in this.mGlyphs.Values)
                {
                    var glyphBmp = CropGlyphBitmap(sourceBmp, glyph);
                    var glyphFilename = String.Format("glyph_{0:D4}.png", glyphCount);
                    glyphBmp.Save(glyphFilename);

                    xml.WriteStartElement("Glyph");
                    xml.WriteAttributeString("Character", glyph.Character.ToString());
                    xml.WriteAttributeString("AdvanceWidth", glyph.AdvanceWidth.ToString());
                    xml.WriteAttributeString("ForceWhite", glyph.ForceWhite.ToString());
                    xml.WriteAttributeString("LeftSideBearing", glyph.LeftSideBearing.ToString());
                    xml.WriteAttributeString("src",glyphFilename);

                    if (this.mKerning.ContainsKey(glyph.Character))
                    {
                        foreach (var kern in this.mKerning[glyph.Character])
                        {
                            xml.WriteStartElement("Kerning");
                            xml.WriteAttributeString("char", kern.Key.ToString());
                            xml.WriteAttributeString("value", kern.Value.ToString());
                            xml.WriteEndElement();
                        }

                    }
                    
                    xml.WriteEndElement();

                    glyphCount += 1;
                }
                xml.WriteEndElement();
            }

            Directory.SetCurrentDirectory(beforeCurrentPath);
        }

        public D.Bitmap CropGlyphBitmap(D.Bitmap sourceBMP,Glyph glyph)
        {
            // まれに0x0のフォントがある?のでそれを避けるためのバッドノウハウ
            D.Bitmap bmp = new System.Drawing.Bitmap(Math.Max(1,glyph.Size.X), Math.Max(1,glyph.Size.Y));
            using (D.Graphics g = D.Graphics.FromImage(bmp))
            {
                g.DrawImage(
                    sourceBMP,
                    new D.Rectangle(0, 0, bmp.Width, bmp.Height),
                    new D.Rectangle(glyph.Origin.X, glyph.Origin.Y, bmp.Width, bmp.Height),
                    System.Drawing.GraphicsUnit.Pixel);
            }
            return bmp;
        }

        /// <summary>
        ///     Textrue 2DをTexture2DContentにする(System.Drawing.Bitmap経由)
        /// </summary>
        /// <param name="tex"></param>
        /// <returns></returns>
        public static Texture2DContent T2D2T2C(Texture2D tex)
        {
            var pngFilename = Path.GetTempFileName() + ".png";
            
            tex.Save(pngFilename, ImageFileFormat.Png);
            using (var bmp = new System.Drawing.Bitmap(pngFilename))
            {
                switch (bmp.PixelFormat)
                {
                    case D.Imaging.PixelFormat.Format32bppArgb:
                       return BMP2T2C_32argb(bmp);
                    case D.Imaging.PixelFormat.Format24bppRgb:
                        return null;
                    default:
                        return BMP2T2C_slow(bmp);
                }
            }
        }

        public static Texture2DContent BMP2T2C_24rgb(D.Bitmap bmp)
        {
            PixelBitmapContent<XnaColor> pbc = new PixelBitmapContent<XnaColor>(bmp.Width, bmp.Height);
            
            D.Imaging.BitmapData bData = bmp.LockBits(
                new D.Rectangle(D.Point.Empty, bmp.Size),
                D.Imaging.ImageLockMode.ReadOnly,
                D.Imaging.PixelFormat.Format24bppRgb);
            try
            {
                Byte[] buf = new Byte[bData.Stride * bData.Height];

                System.Runtime.InteropServices.Marshal.Copy(bData.Scan0, buf, 0, buf.Length);
                
                for (int x = 0; x < bmp.Width; x++)
                {
                    for (int y = 0; y < bmp.Height; y++)
                    {
                        int pt = x * 3 + y * bData.Stride;
                        pbc.SetPixel(x, y, new XnaColor(buf[pt + 2], buf[pt + 1], buf[pt + 0], 255));

                    }
                }
            }
            finally
            {
                bmp.UnlockBits(bData);
            }
            var result = new Texture2DContent();
            result.Mipmaps.Add(pbc);

            return result;
        }

        public static Texture2DContent BMP2T2C_32argb(D.Bitmap bmp)
        {
            PixelBitmapContent<XnaColor> pbc = new PixelBitmapContent<XnaColor>(bmp.Width, bmp.Height);

            D.Imaging.BitmapData bData = bmp.LockBits(
                new D.Rectangle(D.Point.Empty, bmp.Size),
                D.Imaging.ImageLockMode.ReadOnly,
                D.Imaging.PixelFormat.Format32bppArgb);
            try
            {
                Byte[] buf = new Byte[bData.Stride * bData.Height];

                System.Runtime.InteropServices.Marshal.Copy(bData.Scan0, buf, 0, buf.Length);

                for (int x = 0; x < bmp.Width; x++)
                {
                    for (int y = 0; y < bmp.Height; y++)
                    {
                        int pt = x * 4 + y * bData.Stride;
                        // ABGR ?
                        pbc.SetPixel(x, y, new XnaColor(buf[pt + 2], buf[pt + 1], buf[pt + 0], buf[pt + 3]));
                    }
                }
            }
            finally
            {
                bmp.UnlockBits(bData);
            }
            var result = new Texture2DContent();
            result.Mipmaps.Add(pbc);

            return result;
        }

        public static Texture2DContent BMP2T2C_slow(D.Bitmap bmp)
        {
            PixelBitmapContent<XnaColor> pbc = new PixelBitmapContent<XnaColor>(bmp.Width, bmp.Height);
            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    var dc = bmp.GetPixel(x,y);              
                    pbc.SetPixel(x, y, new XnaColor(dc.R,dc.G,dc.B,dc.A));
                }
            }
            var result = new Texture2DContent();
            result.Mipmaps.Add(pbc);
            return result;
        }

        
    }
}
