﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Xml;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Content.Pipeline.Graphics;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Compiler;
using Microsoft.Xna.Framework.Graphics;
using D = System.Drawing;
using XnaColor = Microsoft.Xna.Framework.Graphics.Color;



namespace PolygonHead
{


    public class AcientBitmapFont
    {
        #region Members var
        protected int mBaseLine;

        protected Dictionary<char, Character> mCharacters;

        protected char mDefaultCharacter;

        protected Dictionary<char, Glyph> mGlyphs;

        protected Dictionary<char, Dictionary<char, int>> mKerning;

        protected int mLineHeight;

        protected int mSpacing;

        protected Texture2D mTexture;

        public int Baseline
        {
            get
            {
                return this.mBaseLine;
            }
            set
            {
                this.mBaseLine = value;
            }
        }

        public int LineHeight
        {
            get
            {
                return this.mLineHeight;
            }
        }

        public int Spacing
        {
            get
            {
                return this.mSpacing;
            }
        }

        public Texture2D Texture
        {
            get
            {
                return this.mTexture;
            }
        }

        #endregion


        public AcientBitmapFont()
        {
        }

        #region 重要度の低い物
        public int CalcKern(char iLeft, char iRight)
        {
            Dictionary<char, int> chrs = null;
            int num = 0;
            if (this.mKerning.TryGetValue(iLeft, out chrs) && chrs.TryGetValue(iRight, out num))
            {
                return num;
            }
            return 0;
        }

        public Vector2 MeasureText(char[] iText, bool iKern)
        {
            return this.MeasureText(iText, iKern, (int)iText.Length);
        }

        public Vector2 MeasureText(char[] iText, bool iKern, int iLength)
        {
            Glyph glyph;
            Glyph glyph2;
            Vector2 y = new Vector2();
            y.Y = (float)this.mLineHeight;
            int advanceWidth = 0;
            char chr1 = '\0';
            bool flag = false;
            iLength = Math.Min((int)iText.Length, iLength);
            int num = 0;
            while (num < iLength)
            {
                char chr2 = iText[num];
                if (flag)
                {
                    if (chr2 == 91)
                    {
                        this.GetGlyph(chr2, out glyph);
                        if (iKern)
                        {
                            advanceWidth = advanceWidth + this.CalcKern(chr1, chr2);
                            chr1 = chr2;
                        }
                        advanceWidth = advanceWidth + glyph.AdvanceWidth + this.mSpacing;
                        flag = false;
                        continue;
                    }
                    if (chr2 == 93)
                    {
                        flag = false;
                        continue;
                    }
                }
                else
                {
                    if (chr2 != '\0')
                    {
                        if (chr2 == 10)
                        {
                            y.Y = y.Y + (float)this.mLineHeight;
                            y.X = Math.Max(y.X, (float)advanceWidth);
                            advanceWidth = 0;
                        }
                        if (chr2 == 91 && !flag)
                        {
                            flag = true;
                            continue;
                        }
                        this.GetGlyph(chr2, out glyph2);
                        if (iKern)
                        {
                            advanceWidth = advanceWidth + this.CalcKern(chr1, chr2);
                            chr1 = chr2;
                        }
                        advanceWidth = advanceWidth + glyph2.AdvanceWidth + this.mSpacing;
                        num++;
                    }
                }
            }
            y.X = Math.Max(y.X, (float)advanceWidth);
            if (y.X > 1)
            {
                y.X = y.X - (float)this.mSpacing;
            }
            return y;
        }

        public Vector2 MeasureText(string iText, bool iKern)
        {
            return this.MeasureText(iText, iKern, iText.Length);
        }

        public Vector2 MeasureText(string iText, bool iKern, int iLength)
        {
            Glyph glyph;
            Glyph glyph2;
            Vector2 y = new Vector2();
            y.Y = (float)this.mLineHeight;
            int advanceWidth = 0;
            char chr = '\0';
            bool flag = false;
            iLength = Math.Min(iText.Length, iLength);
            int num = 0;
            while (num < iLength)
            {
                char chars = iText[num];
                if (flag)
                {
                    if (chars == 91)
                    {
                        this.GetGlyph(chars, out glyph);
                        if (iKern)
                        {
                            advanceWidth = advanceWidth + this.CalcKern(chr, chars);
                            chr = chars;
                        }
                        advanceWidth = advanceWidth + glyph.AdvanceWidth + this.mSpacing;
                        flag = false;
                        continue;
                    }
                    if (chars == 93)
                    {
                        flag = false;
                        continue;
                    }
                }
                else
                {
                    if (chars != '\0')
                    {
                        if (chars == 10)
                        {
                            y.Y = y.Y + (float)this.mLineHeight;
                            y.X = Math.Max(y.X, (float)advanceWidth);
                            advanceWidth = 0;
                        }
                        if (chars == 91 && !flag)
                        {
                            flag = true;
                            continue;
                        }
                        this.GetGlyph(chars, out glyph2);
                        if (iKern)
                        {
                            advanceWidth = advanceWidth + this.CalcKern(chr, chars);
                            chr = chars;
                        }
                        advanceWidth = advanceWidth + glyph2.AdvanceWidth + this.mSpacing;
                        num++;
                    }
                }
            }
            y.X = Math.Max(y.X, (float)advanceWidth);
            if (y.X > 1)
            {
                y.X = y.X - (float)this.mSpacing;
            }
            return y;
        }
        public string Wrap(string iText, int iTargetLineWidth, bool iKern)
        {
            return this.Wrap(iText, iTargetLineWidth, iKern, out iTargetLineWidth);
        }

        public string Wrap(string iText, int iTargetLineWidth, bool iKern, out int oLineWidth)
        {
            int length = 0;
            Glyph glyph;
            // Glyph glyph2;
            string str = "";
            while (!false)
            {
                str = "";
                for (int i = 0; i < iText.Length; i = length + 1)
                {
                    length = iText.Length;
                    int num1 = 0;
                    int advanceWidth = 0;
                    char chr = '\0';
                    bool flag = false;
                    int num2 = i;
                    while (num2 < iText.Length)
                    {
                        char chars = iText[num2];
                        if (flag)
                        {
                            if (chars == 91)
                            {
                                this.GetGlyph(chars, out glyph);
                                if (iKern)
                                {
                                    advanceWidth = advanceWidth + this.CalcKern(chr, chars);
                                    chr = chars;
                                }
                                advanceWidth = advanceWidth + glyph.AdvanceWidth + this.mSpacing;
                                flag = false;
                            }
                            else
                            {
                                if (chars == 93)
                                {
                                    flag = false;
                                }
                                if (chars == 32)
                                {
                                    if (advanceWidth <= iTargetLineWidth || num2 < length)
                                    {
                                        length = num2;
                                        num1 = advanceWidth;
                                    }
                                }
                                if (chars != '\0')
                                {
                                    if (chars == 10)
                                    {
                                        length = num2;
                                    }
                                    else
                                    {
                                        if (chars == 91 && !flag)
                                        {
                                            flag = true;
                                        }
                                        if (advanceWidth <= iTargetLineWidth || num2 >= length)
                                        {
                                            break;
                                        }
                                        num2++;
                                    }
                                }
                            }
                        }
                    }
                    if (num2 == iText.Length && advanceWidth <= iTargetLineWidth)
                    {
                        num1 = advanceWidth;
                        length = num2;
                    }
                    if (num1 > iTargetLineWidth)
                    {
                        iTargetLineWidth = num1;
                        break;
                    }
                    str = string.Concat(str, iText.Substring(i, length - i));
                    if (length < iText.Length)
                    {
                        str = string.Concat(str, 10);
                    }
                }
            }
            //oLineWidth = iTargetLineWidth;
            //return str;
        }


        public bool GetCharacter(char iChar, out Character oChar)
        {
            if (!this.mCharacters.TryGetValue(iChar, out oChar))
            {
                if (!this.mCharacters.TryGetValue(this.mDefaultCharacter, out oChar))
                {

                    //Enumerat<char, Character> 
                    var enumerator = this.mCharacters.Values.GetEnumerator();
                    enumerator.MoveNext();
                    oChar = enumerator.Current;
                }
                return false;
            }
            return true;
        }

        public bool GetGlyph(char iChar, out Glyph oGlyph)
        {
            if (!this.mGlyphs.TryGetValue(iChar, out oGlyph))
            {
                if (!this.mGlyphs.TryGetValue(this.mDefaultCharacter, out oGlyph))
                {
                    //Enumerat<char, Glyph> 
                    var enumerator = this.mGlyphs.Values.GetEnumerator();
                    enumerator.MoveNext();
                    oGlyph = enumerator.Current;
                }
                return false;
            }
            return true;
        }
        #endregion

        public void Read(ContentReader iInput)
        {

            int num1 = 0;
            Glyph glyph;
            Character character;
            Dictionary<char, int> chrs = null;
            this.mSpacing = 0;
            this.mLineHeight = iInput.ReadInt32();
            this.mBaseLine = iInput.ReadInt32();
            this.mDefaultCharacter = iInput.ReadChar();
            GraphicsDevice graphicsDevice1 = null;
            for (int i = 0; i < num1; i++)
            {
                glyph = Glyph.Read(iInput);
                this.mGlyphs.Add(glyph.Character, glyph);
                character = Character.FromGlyph(glyph, Vector4.One, this.mTexture.Width, (float)this.mTexture.Height);
                this.mCharacters.Add(glyph.Character, character);
            }
            GraphicsDevice graphicsDevice2 = graphicsDevice1;
            //Monitor.Enter(graphicsDevice2);
            try
            {
                this.mTexture = iInput.ReadObject<Texture2D>();
            }
            finally
            {
                //Monitor.Exit(graphicsDevice2);
            }
            num1 = iInput.ReadInt32();
            this.mGlyphs = new Dictionary<char, Glyph>(); // (num1)
            this.mCharacters = new Dictionary<char, Character>(); // (num1)
            for (int i = 0; i < num1; i++)
            {
                glyph = Glyph.Read(iInput);
                this.mGlyphs.Add(glyph.Character, glyph);
                character = Character.FromGlyph(glyph, Vector4.One, this.mTexture.Width, (float)this.mTexture.Height);
                this.mCharacters.Add(glyph.Character, character);
            }
            int num2 = iInput.ReadInt32();
            this.mKerning = new Dictionary<char, Dictionary<char, int>>();
            int num3 = 0;
            while (num3 < num2)
            {
                char chr1 = iInput.ReadChar();
                char chr2 = iInput.ReadChar();
                int num4 = iInput.ReadInt32();
                if (!this.mKerning.TryGetValue(chr1, out chrs))
                {
                    chrs = new Dictionary<char, int>();
                    this.mKerning.Add(chr1, chrs);
                }
                chrs.Add(chr2, num4);
                num3++;
            }
        }




    }


}
