﻿using System.IO;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Content.Pipeline;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Compiler;


namespace PolygonHead.Pipeline
{
    public class BitmapFontReader : ContentTypeReader<BitmapFont>
    {
        public BitmapFontReader()
        {
        }

        protected override BitmapFont Read(ContentReader iInput, BitmapFont existingInstance)
        {
            if (existingInstance == null)
            {
                existingInstance = new BitmapFont();
            }
            existingInstance.Read(iInput);
            return existingInstance;

        }
    }


    [ContentTypeWriter]
    public class BitmapFontTypeWriter : ContentTypeWriter<BitmapFont>
    {
        protected override void Write(ContentWriter output, BitmapFont value)
        {
            // TODO: write the specified value to the output ContentWriter.
            value.Write(output);



        }

        public override string GetRuntimeReader(TargetPlatform targetPlatform)
        {
            // TODO: change this to the name of your ContentTypeReader
            // class which will be used to load this data.
            return "PolygonHead.Pipeline.BitmapFontReader, PolygonHead";

        }
    }

    [ContentImporter(".packagedbitmapfontxml", DisplayName = "PackagedBitmapFontXml Importer", DefaultProcessor = "PackagedBitmapFontXmlProcessor")]
    public class PackagedBitmapFontXmlImporter : ContentImporter<MemoryStream>
    {
        public override MemoryStream Import(string filename, ContentImporterContext context)
        {
            return new MemoryStream(File.ReadAllBytes(filename));
        }
    }

    [ContentProcessor(DisplayName = "PackagedBitmapFontXml Processor")]
    public class PackagedBitmapFontXmlProcessor : ContentProcessor<Stream, BitmapFont>
    {
        public override BitmapFont Process(Stream input, ContentProcessorContext context)
        {
            if (System.Diagnostics.Debugger.IsAttached) System.Diagnostics.Debugger.Break();
            return new BitmapFont(input);
        }
    }

}