using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;
using System.IO;

namespace WindowsGame1
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = ".";

            
        }

        private void ExtractXNBFont(String assetFile)
        {
            var assetName = Path.GetFileNameWithoutExtension(assetFile);
            this.Content.RootDirectory = Path.GetDirectoryName(assetFile);
            var bmpfnt = this.Content.Load<PolygonHead.BitmapFont>(assetName);

            using (var bftStream = File.Create(assetName + @"backup.packagedbitmapfontxml"))
            {
                bmpfnt.SavePackageXML(bftStream);
            }

            bmpfnt.SaveIndividual(assetName);

            this.Content.Unload();
        }

        protected override void Initialize()
        {
            base.Initialize();
            var args = Environment.GetCommandLineArgs();

            for (int i = 1; i < args.Length; i++)
            {
                Console.WriteLine(args[i]);

                ExtractXNBFont(args[i]);
            }
            this.Exit();
        }

        protected override void LoadContent()
        {
            spriteBatch = new SpriteBatch(GraphicsDevice);
        }

        protected override void UnloadContent()
        {

        }

        protected override void Update(GameTime gameTime)
        {
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();
            base.Update(gameTime);
        }

        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);
            base.Draw(gameTime);
        }
    }
}
