﻿using System;
using System.IO;
using System.Text;

namespace FontCombine
{
    class Program
    {
        static void Main(string[] args)
        {
            try
            {
                foreach (var item in args)
                {
                    Console.WriteLine(item);
                    Console.WriteLine("　の読み込み中[1/4]");
                    using (Combinner binner = new Combinner(item + @"\glyphs.xml"))
                    {
                        Console.Write("テクスチャサイズ予想[2/4]");
                        binner.AnalogyTextureSize1();
                        Console.WriteLine("{0}x{1}", binner.texture.Width, binner.texture.Height);
                        Console.WriteLine("配置[3/4]");
                        binner.PlaceGlyphs1();
                        Console.WriteLine("ファイルへ書きだし[4/4]");
                        var outputProjectName = String.Format(@"{0}\combined.packagedbitmapfontxml", item);
                        MakeProjectFile(item);
                        binner.texture.Save(String.Format(@"{0}\combined.png", item));
                        binner.SavePackageXML(item+@"\combined.packagedbitmapfontxml");
                        Console.WriteLine("つ" + outputProjectName);
                    }
                }
            }
			catch (Exception e)
            {
                Console.Error.WriteLine("何らかのエラーが発生しました");
                ShowError(e,20);
            }
			Console.WriteLine("Bye!");
        }

        static void ShowError(Exception ex,int life)
        {
            Console.Error.WriteLine("MSG:{0}",ex.Message);
            Console.Error.WriteLine("Source:{0}",ex.Source);
            if (ex.InnerException != null && life > 0) ShowError(ex.InnerException,life -1);
        }

        static String GetProjectTemplate()
        {
            if (File.Exists("ContentProjectTemplate.xml"))
            {
                return File.ReadAllText("ContentProjectTemplate.xml", Encoding.UTF8);
            }
            else
            {
                return Resource1.XNBProjectTemplate;
            }

        }

        static void MakeProjectFile(String workingDirectry)
        {
            var assertName = workingDirectry.IndexOf('\\') == -1 ? workingDirectry : workingDirectry.Substring(workingDirectry.LastIndexOf('\\')+1);

            var content = GetProjectTemplate();
            content = content.Replace("###source###", workingDirectry + @"\combined.packagedbitmapfontxml");
            content = content.Replace("###assetname###", assertName);
            File.WriteAllText(workingDirectry + ".contentproj", content);
        }
    }
}
